; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

		opt		h+o+

		icl		'library.s'

		org		$e0
verdet	dta		0

VERONICA_CTL = $D5C0

;============ NON-RESIDENT SECTION ============	
	
		org		$2000

.proc main
		;save and turn off display (it may or may not be on)
		lda		sdmctl
		pha
		lda		#0
		sta		sdmctl
		sta		dmactl
		sei

		;turn on both windows, make sure they are read/write
		lda		$8000
		pha
		eor		#$55
		tax
		lda		$A000
		pha
		eor		#$33
		tay

		mva		#$38 VERONICA_CTL

		lda		#0
		stx		$8000
		sty		$A000
		cpx		$8000
		seq:adc	#1
		cpy		$A000
		seq:adc	#1

		tax

		pla
		sta		$A000
		pla
		sta		$8000

		mva		#0 VERONICA_CTL

		txa
		bne		veronica_fail

		;upload resident code
		mva		#$28 VERONICA_CTL
		ldy		#0
		mva:rne	$3F00,y $BF00,y+

		;launch
		mva		#$AB VERONICA_CTL

vwait:
		bit		VERONICA_CTL
		bpl		veronica_pass
		dey
		bne		vwait

veronica_fail:
		pla
		sta		sdmctl
		mva		#0 VERONICA_CTL
		cli
		jsr		_imprint
		dta		c"Error: Veronica not found.",$9b,$9b,0
		jmp		_waitKeyPrompt

veronica_pass:
		pla
		sta		sdmctl
		mva		#0 VERONICA_CTL
		cli
		mva		#$ff _veronica
		rts
.endp

;==========================================================================
; RESIDENT CODE (6502)
;==========================================================================
		org		$0900

.nowarn .proc _veronicaLaunch2
		;temporarily turn off display and suspend stage 2 VBLANK
		pha
		lda		sdmctl
		sta		sdmctl_save
		lda		#0
		sta		sdmctl
		sta		dmactl
		sei

		;bank in Veronica
		mva		#$a8 $d5c0

		;copy module to Veronica
		pla
		stx		vrun_addr-$4000
		sta		vcopy_dst+1-$4000
		sta		copy_src+1
		lda		d0
		sta		vrun_addr+1-$4000
		sty		pages

		lda		#0
		sta		vcopy_src-$4000
		sta		vcopy_dst-$4000
		sta		vcopy_cnt-$4000
		mva		#$e0 vcopy_src+1-$4000
		mva		#1 vcopy_cnt+1-$4000

		ldy		#0
pages = *-1
		ldx		#0
copy_loop:
		lda.w	$0000,x
copy_src = *-2
		sta		$A000,x
		inx
		bne		copy_loop
		
		lda		#<vcopy
		jsr		do_launch

		inc		copy_src+1
		inc		vcopy_dst+1-$4000
		dey
		bne		copy_loop

		;copy module zero page to Veronica
		ldx		#$3f
		mva:rpl	$80,x $a000,x-

		lda		#0
		sta		vcopy_dst+1-$4000
		sta		vcopy_cnt+1-$4000
		mva		#$80 vcopy_dst-$4000
		mva		#$40 vcopy_cnt-$4000
		lda		#<vcopy
		jsr		do_launch

		;run it
		lda		#<vrun
		jsr		do_launch

		;copy module zero page back
		ldx		#$3f
		mva:rpl	$a080,x $80,x-

		;copy out registers
		lda		vsave_p-$4000
		and		#$fc
		pha
		lda		vsave_a-$4000
		pha
		lda		vsave_x-$4000
		pha
		lda		vsave_y-$4000
		pha

		;turn off Veronica and restore display
		mva		#0 $d5c0

		lda		#0
sdmctl_save = *-1
		sta		sdmctl

		;load registers and exit
		pla
		tay
		pla
		tax
		pla
		plp
		cld
		rts

do_launch:
		sta		$bffc
		mva		#$ab $d5c0
		bit:rmi	$d5c0
		mva		#$a8 $d5c0
		rts
.endp

;==========================================================================
; RESIDENT CODE (VERONICA)
;==========================================================================

		opt		c+

		org		$FF00,$3F00
vinit	jmp		vinit2
vrun	jmp		vrun2
vcopy	jmp		vcopy2

vinit2:
		lda		#$a5
		sta		$ffff
		jmp		vexit

vrun2:
		ldx		#$ff
		txs

		;run test routine (launch in emu mode)
		jsr		0
vrun_addr = *-2

vrun_resume:
		;save registers and switch to native mode
		php
		clc
		xce
		sep		#$38
		sta		vsave_a
		stx		vsave_x
		sty		vsave_y
		pla
		sta		vsave_p

		;copy page zero to shared window and return
		rep		#$30
		ldx.w	#0
		ldy.w	#$fe00
		lda.w	#$00ff
		mvn		0,0
		jmp		vexit

vecop:
vncop:
		plp
		jmp		vrun_resume

vcopy2:
		clc
		xce
		rep		#$30
		ldx.w	#0
vcopy_src = *-2
		ldy.w	#0
vcopy_dst = *-2
		lda.w	#0
vcopy_cnt = *-2
		dec
		mvn		0,0
		jmp		vexit

vexit:
		sep		#$30
		lda		#$80
		tsb		$0200
		nop
		jmp		*

vsave_a	dta		0
vsave_x	dta		0
vsave_y	dta		0
vsave_p	dta		0

		org		$FFE0,$3FE0
		jmp		vrun_resume
		nop
		dta		a(vncop)		;FFE4 Native COP
		dta		a(0)			;FFE6
		dta		a(0)			;FFE8
		dta		a(0)			;FFEA
		dta		a(0)			;FFEC
		dta		a(0)			;FFEE
		dta		a(0)			;FFF0
		dta		a(0)			;FFF2
		dta		a(vecop)		;FFF4 Emulation COP
		dta		a(0)			;FFF6
		dta		a(0)			;FFF8
		dta		a(0)			;FFFA
		dta		a(vinit)		;FFFC Reset
		dta		0,0

;==========================================================================

		run		main
		end
